<!--
 * @Title: 
 * @Description: 
 * @Author: 893699165@qq.com
 * @Date: 2022-08-24 10:49:21
 * @LastEditors: 
 * @LastEditTime: 2022-08-24 10:49:21
-->
<template>
    <div>
        <el-row>
            <el-col :span="5">
                <div class="box">
                    <el-scrollbar>
                        <basic-container>
                            <avue-tree :option="treeOption" :data="projectTreeData" @node-click="nodeClick">
                                <span class="el-tree-node__label" slot-scope="{ node, data }">
                                    <span>
                                        <i class="el-icon-user-solid"></i>
                                        {{ (node || {}).label }}
                                    </span>
                                </span>
                                <template slot-scope="scope" slot="menu">
                                    <div class="avue-tree__item" @click.native="tip(scope.node,scope.data)">自定义按钮</div>
                                </template>
                            </avue-tree>
                        </basic-container>
                    </el-scrollbar>
                </div>
            </el-col>
            <el-col :span="19">
                <basic-container>
                    <avue-crud :option="option" :table-loading="loading" :page.sync="page" :data="data" ref="crud"
                        v-model="form" :permission="permissionList" @row-del="rowDel" @row-update="rowUpdate"
                        @row-save="rowSave" @search-change="searchChange" @search-reset="searchReset"
                        @selection-change="selectionChange" @current-change="currentChange" @size-change="sizeChange"
                        @refresh-change="refreshChange" @on-load="onLoad" @before-open="beforeOpen">
                        <template slot="runStatusId" slot-scope="row">
                            <div v-if="row.row.runStatusId==0" style="color: blue;">
                                正常
                            </div>
                            <div v-else style="color: orangered;">
                                预警
                            </div>
                        </template>
                        <template slot-scope="{ row, index }" slot="menu">
                            <!-- <el-button
                type="text"
                size="small"
                @click="$refs.crud.rowView(row, index)"
                >预警配置
              </el-button> -->
                            <el-button type="text" size="small" @click="openWarnInfo(row)">预警信息
                            </el-button>
                            <el-button type="text" size="small" @click="openOrder(row)">维修工单
                            </el-button>
                        </template>
                    </avue-crud>
                </basic-container>
            </el-col>
        </el-row>
        <!-- <el-dialog
      title="预警配置"
      :visible.sync="configDialog"
      width="600px"
      :before-close="handleClose"
      :close-on-click-modal="false"
      append-to-body
    >
      <el-form label-width="120px">
        <el-form-item label="预警总开关">
          <el-switch
            v-model="warningConfig.configSw"
            active-color="#13ce66"
            inactive-color="#ff4949"
            active-text="开"
            inactive-text="关"
          >
          </el-switch>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="configDialog = false" size="small">取 消</el-button>
        <el-button type="primary" @click="confirmConfig" size="small"
          >确 定</el-button
        >
      </span>
    </el-dialog> -->
        <el-dialog title="预警信息" :visible.sync="warnInfoDialog" v-if="warnInfoDialog" width="80%"
            :close-on-click-modal="false" append-to-body>
            <rtuWarningList :rtuCode="rtuCode" ref="rtuWarningList"></rtuWarningList>
        </el-dialog>
        <el-dialog title="维修工单" :visible.sync="orderDialog" width="80%" :close-on-click-modal="false" append-to-body>
            <rtuCheckOrder :rtuCode="rtuCode" ref="rtuCheckOrder"></rtuCheckOrder>
        </el-dialog>
    </div>
</template>

<script>
import { getList, getDetail, add, update, remove, getTree } from "@/api/business/manage/manage.js";
// import { mapGetters } from "vuex";
import rtuWarningList from "../warning/rtuWarningList.vue";
import rtuCheckOrder from "../order/rtuCheckOrder.vue";
export default {
    components: {
        rtuWarningList,
        rtuCheckOrder,
    },
    data() {
        return {
            orderDialog: false,
            // warningConfig: {
            // configSw: false,
            // code: "",
            // },
            warnInfoDialog: false,
            //configDialog: false,
            id: "",
            rtuCode: '',
            editForm: {},
            editDialog: false,
            form: {},
            selectionList: [],
            query: {},
            loading: true,
            page: {
                pageSize: 10,
                currentPage: 1,
                total: 0,
            },
            treeCache: {
                orgId: '',
                projectId: '',
            },
            projectTreeData: [

            ],
            treeOption: {
                nodeKey: "id",
                lazy: false,

                // treeLoad: function (node, resolve) {
                // const parentId = node.level === 0 ? 0 : node.data.id;
                // getDeptLazyTree(parentId).then((res) => {
                // resolve(
                // res.data.data.map((item) => {
                // return {
                // ...item,
                // leaf: !item.hasChildren,
                // };
                // })
                // );
                // });
                // },
                defaultExpandAll: true,
                addBtn: false,
                menu: false,
                size: "small",
                props: {
                    labelText: "标题",
                    label: "title",
                    value: "value",
                    children: "children",
                },
            },
            option: {
                labelWidth: 120,
                viewLabelWidth: 100,
                searchlabelWidth: 100,
                height: "auto",
                calcHeight: 30,
                align: "center",
                headerAlign: "center",
                // lazy: true,
                tip: false,
                simplePage: true,
                searchShow: true,
                searchMenuSpan: 6,
                tree: true,
                border: true,
                index: true,
                selection: true,
                viewBtn: false,
                editBtn: false,
                delBtn: false,
                addBtn: false,
                menuWidth: 220,
                dialogType: "drawer",
                dialogClickModal: false,
                column: [
                    {

                        label: "测站名称",
                        prop: "rtuName",
                        search: true,
                        span: 12,
                    },
                    {
                        label: "测站编码",
                        prop: "rtuCode",
                        span: 12,
                        search: true,
                    },
                    {
                        label: "项目名称",
                        prop: "projectName",
                        span: 12,
                    },
                    {
                        label: "测站类型",
                        prop: "rtuKindDesc",
                        span: 24,
                    },

                    {
                        label: "最后上线时间",
                        prop: "lastUpTime",
                        span: 12,
                    },

                    {
                        label: "运行状态",
                        prop: "runStatusId",
                        span: 12,
                        slot: true,
                        //html:true,
                        // formatter:(val)=>{
                        //   if(val.runStatusId==0){

                        //     return '<b style="color:blue">正常</b>'
                        //   }else{

                        //     return '<b style="color:orangered">预警</b>'
                        //   }    
                        //    }
                    },

                ],
            },
            data: [],
        };
    },
    computed: {
        // ...mapGetters(["userInfo", "permission"]),
        permissionList() {
            return {
                // addBtn: this.vaildData(this.permission.docCategory_add, false),
                // viewBtn: this.vaildData(this.permission.docCategory_view, false),
                // delBtn: this.vaildData(this.permission.docCategory_delete, false),
                // editBtn: this.vaildData(this.permission.docCategory_edit, false),
            };
        },
        ids() {
            let ids = [];
            this.selectionList.forEach((ele) => {
                ids.push(ele.id);
            });
            return ids.join(",");
        },
    },
    mounted() { },
    created() {
        this.initTree();
    },
    methods: {
        initTree() {
            getTree(
            ).then((res) => {
                const data = res.data.data;
                this.projectTreeData = data;
            });
        },
        nodeClick(data) {
            this.treeCache.orgId = data.orgId;
            this.treeCache.projectId = data.projectId;
            //this.$message.success(JSON.stringify(data))
            this.query = {};
            this.page.currentPage = 1;
            this.onLoad(this.page);
        },
        confirmConfig() { },
        openConfig(item) {
            this.configSw = item.configSw;
            this.configDialog = true;
        },
        openWarnInfo(item) {
            this.rtuCode = item.rtuCode;
            this.warnInfoDialog = true;
            // this.$nextTick(() => {
            //     this.$refs["rtuWarningList"].init();
            // });
        },
        openOrder(item) {
            this.rtuCode = item.rtuCode;
            this.orderDialog = true;
            this.$nextTick(() => {
                this.$refs["rtuCheckOrder"].init();
            });
        },
        rowSave(row, done, loading) {
            add(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowUpdate(row, index, done, loading) {
            update(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowDel(row) {
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(row.id);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                });
        },
        searchReset() {
            this.query = {};
            this.onLoad(this.page);
        },
        searchChange(params, done) {
            this.query = params;
            this.page.currentPage = 1;
            this.onLoad(this.page, params);
            done();
        },
        selectionChange(list) {
            this.selectionList = list;
        },
        selectionClear() {
            this.selectionList = [];
            this.$refs.crud.toggleSelection();
        },
        handleDelete() {
            if (this.selectionList.length === 0) {
                this.$message.warning("请选择至少一条数据");
                return;
            }
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(this.ids);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    this.$refs.crud.toggleSelection();
                });
        },
        beforeOpen(done, type) {
            if (["edit", "view"].includes(type)) {
                getDetail(this.form.id).then((res) => {
                    this.form = res.data.data;
                });
            }
            done();
        },
        currentChange(currentPage) {
            this.page.currentPage = currentPage;
        },
        sizeChange(pageSize) {
            this.page.pageSize = pageSize;
        },
        refreshChange() {
            this.onLoad(this.page, this.query);
        },
        onLoad(page, params = {}) {
            this.loading = true;
            params['orgId'] = this.treeCache.orgId;
            params['projectId'] = this.treeCache.projectId;
            getList(
                page.currentPage,
                page.pageSize,
                Object.assign(params, this.query)
            ).then((res) => {
                const data = res.data.data;
                this.page.total = data.total;
                this.data = data.records;
                this.loading = false;
                this.selectionClear();
            });
        },
    },
};
</script>
